Subject: Re: [PATCH v2] net: dsa: mv88e6xxx: Fix port_hidden_wait to account for port_base_addr

From: Marek Behún <[email-masked]>
Date: Mon, 25 Apr 2022 01:16:38 +0200

On Mon, 25 Apr 2022 00:33:15 +0200
Andrew Lunn <[email-masked]> wrote:

> On Sun, Apr 24, 2022 at 09:33:59PM +0200, Marek Behún wrote:
> > On Sun, 24 Apr 2022 21:26:58 +0200
> > Andrew Lunn <[email-masked]> wrote:
> >   
> > > On Sun, Apr 24, 2022 at 03:31:43PM +0000, Nathan Rossi wrote:  
> > > > The other port_hidden functions rely on the port_read/port_write
> > > > functions to access the hidden control port. These functions apply the
> > > > offset for port_base_addr where applicable. Update port_hidden_wait to
> > > > use the port_wait_bit so that port_base_addr offsets are accounted for
> > > > when waiting for the busy bit to change.
> > > > 
> > > > Without the offset the port_hidden_wait function would timeout on
> > > > devices that have a non-zero port_base_addr (e.g. MV88E6141), however
> > > > devices that have a zero port_base_addr would operate correctly (e.g.
> > > > MV88E6390).
> > > > 
> > > > Fixes: ea89098ef9a5 ("net: dsa: mv88x6xxx: mv88e6390 errata")    
> > > 
> > > That is further back than needed. And due to the code moving around
> > > and getting renamed, you are added extra burden on those doing the
> > > back port for no actual gain.
> > > 
> > > Please verify what i suggested, 609070133aff1 is better and then
> > > repost.  
> > 
> > The bug was introduced by ea89098ef9a5.  
> 
> I have to disagree with that. ea89098ef9a5 adds:
> 
> mv88e6390_hidden_wait()
> 
> The mv88e6390_ means it should be used with the mv88e6390 family. And
> all members of that family have port offset 0. There is no bug here.
> 
> 609070133aff1 renames it to mv88e6xxx_port_hidden_wait(). It now has
> the generic mv88e6xxx_ prefix, so we can expect it to work with any
> device. But it does not. This is where the bug has introduced.

You are right. My bad, sorry.

Marek